unit okna;
 interface
 uses savewind;

 procedure WTReadln(s: string);
 function TextWindow(x,y: byte; TName: string): boolean;
 procedure WEReadLn(s: string);
 procedure WEReadBt(BJmeno: string; BPrikaz: word; BText: string);
 function ChoiceWindow(cx,cy: byte; Name: string): word;

 procedure InputLnS(LTitle,infotxt: string; x,y,delka: byte; var slovo: string);
 procedure InputLnW(LTitle,infotxt: string; x,y,delka: byte; min,max: word; Var w: word);
 procedure LoginBox(x,y: byte; Var user: string; Var password: string);

 procedure WFrame(x1,y1,x2,y2: byte);
 procedure BtDirect(x,y: byte);
 procedure WEWidthLn;
 function InfoLn(S: string): string;
 procedure ShowLn(Ltitle: string;x,y,delka: byte);
 procedure WriteButton(s: string; Active: boolean);
 procedure WENul;
 var
      LOGResult: boolean;
      ESCResult: boolean;
      WTLines: array [1..23] of string;
      WELines: array [1..23] of string;
      Buttons: array [1..16] of record
                                Jmeno: string;
                                Prikaz: word;
                                Text: string;
                                end;

      WEButtonLnY: byte;
      WEPosBt: array [1..16] of byte;
      WPlace: pbuf;

      wcNormal,wcText,wcDeskB,wcDeskW,wcActButton,wcNoButton,
      wcButtonShadow,wcTitle: byte;
      LnInput,LnTitle,LnStand: byte;
const
      WTCount: byte = 0;
      WTWidth: byte = 0;
      WECount: byte = 0;
      WEWidth: byte = 0;
      BtCount: byte = 0;
      WEMaxLengthButtons: byte = 0;

      btActive=true;
      btNoActive=false;

      LogOK = 1;
      LogAg = 2;
      LogEsc= 3;

 implementation
  uses vstupy,crt;

 var WPole: pbuf;
procedure WTReadln(s: string);
begin
     WTCount:=WTcount+1;
     WTLines[WTCount]:=S;
end;

procedure WTWidthLn;
var Q,pom: byte;
begin
     pom:=0;
     for Q:=1 to WTCount do
      begin
           if pom<Length(WTLines[Q]) then pom:=Length(WTLines[Q]);
      end;
     WTWidth:=pom;
end;

procedure WTNul;
begin
     WTWidth:=0;
     WTCount:=0;
end;

procedure WFrame(x1,y1,x2,y2: byte);
var I: byte;
    wx,wy: byte;
begin
     wx:=wherex;
     wy:=wherey;
     textattr:=wcText;
     window(x1,y1,x2,y2); clrscr;
     window(1,1,80,25);
     gotoxy(wx,wy);

     textattr:=wcDeskB;
     gotoxy(x1-1,y1-1);
     write('');
     for I:=x1 to x2 do write('');
     textattr:=wcDeskW;
     write('');
     textattr:=wcDeskB;
     for I:=y1 to y2 do
      begin
           gotoxy(x1-1,i);
           write('');
      end;
     textattr:=wcDeskW;
     for I:=y1 to y2 do
      begin
           gotoxy(x2+1,i);
           write('');
      end;
     textattr:=wcDeskB;
     gotoxy(x1-1,y2+1); write('');
     textattr:=wcDeskW;
     for I:=x1 to x2 do write('');
     write('');
end;

function TextWindow(x,y: byte; TName: string): boolean;
var I: byte;
    key: char;
begin
     WTWidthLN;
     savewin(x-1,y-1,x+WTWidth,y+WTCount+3,WPlace);
     WFrame(x,y,x+WTWidth-1,y+WTCount+2);
     textattr:=wcText;
     for I:=1 to WTCount do
      begin
           gotoxy(x,y+I-1);
           write(WTLines[I]);
      end;
     gotoxy(x+(WTWidth div 2)-2,y+WTCount+1);
     textattr:=wcActButton;
     write(' OK ');
     textattr:=wcButtonShadow;
     write('');
     gotoxy(x+(WTWidth div 2)-2+1,y+WTCount+2);
     write('');
     gotoxy(x+(WTWidth div 2)-(Length(TName) div 2)-1,y-1);
     textattr:=wcTitle;
     write(' ',Tname,' ');
     key:=GetLegalKey([CR,ESC]);
     case key of
     ESC: TextWindow:=false;
     CR: TextWindow:=true;
     end;
     restorewin(x-1,y-1,x+WTWidth,y+WTCount+3,WPlace);
     WTNul;
end;

procedure WEReadLn(s: string);
begin
     WECount:=WECount+1;
     WELines[WECount]:=s;
end;

procedure WEWidthLn;
var Q,pom: byte;
begin
     pom:=0;
     for Q:=1 to WECount do
         if pom<Length(WELines[Q]) then pom:=length(WELines[Q]);

     WEWidth:=pom;
end;

procedure WENul;
begin
     WEWidth:=0;
     WECount:=0;
     BtCount:=0;
     WEMaxLengthButtons:=0;
end;

procedure WriteButton(s: string; Active: boolean);
var x,I: byte;
begin
     x:=wherex;
     if active then textattr:=wcActButton else textattr:=wcNoButton;
     write(s);
     textattr:=wcButtonShadow;
     gotoxy(x+1,WEButtonLnY+1);
     for I:=1 to Length(s) do
      write('');
     gotoxy(x+length(s),WEButtonLnY);
     write('');
end;

procedure WEReadBt(BJmeno: string; BPrikaz: word; BText: string);
begin
     BtCount:=BtCount+1;
     Buttons[BtCount].jmeno:=BJmeno;
     Buttons[BtCount].prikaz:=BPrikaz;
     Buttons[BtCount].text:=BText;
end;

procedure BtDirect(x,y: byte);
var I,Bx: byte;
begin
     for I:=1 to BtCount do
         WEMaxLengthButtons:=WEMaxLengthButtons+Length(Buttons[I].jmeno)+2;

     WEMaxLengthButtons:=WEMaxLengthButtons+1;
     if WEWidth<WEMaxLengthButtons then WEWidth:=WEMaxLengthButtons;
     WEButtonLnY:=y+WECount+1;
     Bx:=x+((WEWidth-WEMaxLengthButtons) div 2)+1;
     WEPosBt[1]:=bx;

     for I:=2 to BtCount do
         WEPosBt[I]:=WEPosBt[I-1]+Length(Buttons[I-1].jmeno)+2;
end;

function InfoLn(S: string): string;
var I: integer;
begin
     for I:=1 to 36-(length(S) div 2) do s:=concat(' ',s,' ');
     Infoln:=s;
end;

function ChoiceWindow(cx,cy: byte; Name: string): word;
var I, BLast, BPos: byte;
    key: char;
begin
     WEWidthLn;
     BtDirect(cx,cy);
     Savewin(cx-1,cy-1,cx+WEWidth,cy+WECount+3,WPlace);
     WFrame(cx,cy,cx+WEWidth-1,cy+WECount+2);
     textattr:=wcText;
     for I:=1 to WECount do
      begin
           gotoxy(cx,cy+I-1);
           write(WELines[I]);
      end;
     for I:=1 to BtCount do
      begin
           gotoxy(WEPosBt[I],WEButtonLnY);
           writeButton(Buttons[I].jmeno,btNoActive);
      end;
     textattr:=wcTitle;
     gotoxy(cx+(WEWidth div 2)-(Length(Name) div 2)-1,cy-1);
     write(' ',Name,' ');
     BLast:=1;
     BPos:=1;

     gotoxy(WEPosBt[Bpos],WEButtonLnY);
     writebutton(Buttons[BPos].jmeno,btActive);
     textattr:=wcText;
     gotoxy(4,23);
     write(infoln(Buttons[BPos].text));

     repeat
           key:=GetLegalKey([CR,ESC,TAB]);
           case key of
            TAB:
                begin
                     BLast:=Bpos;
                     BPos:=BPos+1;
                     if BPos=BtCount+1 then BPos:=1;
                end;
            end;

           gotoxy(WEPosBt[BLast],WEButtonLnY);
           writebutton(Buttons[BLast].jmeno,btNoActive);
           gotoxy(WEPosBt[BPos],WEButtonLnY);
           writebutton(Buttons[BPos].jmeno,btActive);
           textattr:=wcText;
           gotoxy(4,23);
           write(infoln(Buttons[BPos].text));
     until key in [CR,ESC];

     case key of
     CR: ChoiceWindow:=Buttons[Bpos].prikaz;
     ESC: ChoiceWindow:=0;
     end;

     restorewin(cx-1,cy-1,cx+WEWidth,cy+WECount+3,WPlace);
     WENul;
end;

procedure InputLnS(LTitle,infotxt: string;x,y,delka: byte; Var slovo: string);
var
   ix,iy: byte;
begin
     gotoxy(4,23);
     textattr:=wcText;
     write(infoln(infotxt));
     gotoxy(x,y);
     ix:=wherex;
     iy:=wherey;
     textattr:=LnTitle;
     write(LTitle,':');
     textattr:=LnInput;
     window(x+Length(Ltitle)+2,y,x+Length(Ltitle)+2+delka,y);
     clrscr;
     obnovkursor;
     slovo:=getstring(wherex,wherey,delka);
     textattr:=LnStand;
     skryjkursor;
     window(1,1,80,25);
     gotoxy(ix,iy);
end;

procedure InputLnP(LTitle,infotxt: string;x,y,delka: byte; Var slovo: string);
var
   ix,iy: byte;
   key: char; pomslovo: string[22];
   krok: byte;
begin
     gotoxy(4,23);
     textattr:=wcText;
     write(infoln(infotxt));
     gotoxy(x,y);
     ix:=wherex;
     iy:=wherey;
     textattr:=LnTitle;
     write(LTitle,':');
     textattr:=LnInput;
     window(x+Length(Ltitle)+2,y,x+Length(Ltitle)+2+delka,y);
     clrscr;
     obnovkursor;
     pomslovo:='';
     krok:=0;
     repeat
           key:=getkey;
           if key=CR then break;
           krok:=krok+1;
           write('*');
           {sound(880); delay(50); nosound;}
           pomslovo:=pomslovo+key;
     until (key in [CR]) or (krok=22);
     skryjkursor;

     slovo:=pomslovo;
     textattr:=LnStand;
     window(1,1,80,25);
     gotoxy(ix,iy);
end;

procedure InputLnW(LTitle,infotxt: string; x,y,delka: byte; min,max: word; Var w: word);
var ix,iy: byte;
begin
     gotoxy(4,23);
     textattr:=wcText;
     write(infoln(infotxt));
     gotoxy(x,y);
     textattr:=LnTitle;
     ix:=wherex;
     iy:=wherey;
     write(Ltitle,':');
     textattr:=LnInput;
     window(x+Length(Ltitle)+2,y,x+Length(Ltitle)+2+delka,y);
     clrscr;
     obnovkursor;
     w:=GetInteger(wherex,wherey,delka-1,min,max);
     textattr:=LnStand;
     skryjkursor;
     window(1,1,80,25);
     gotoxy(ix,iy);
end;

procedure ShowLn(Ltitle: string;x,y,delka: byte);
var ix,iy: byte;
begin
     gotoxy(x,y);
     ix:=wherex;
     iy:=wherey;
     textattr:=lnTitle;
     write(LTitle,':');
     textattr:=LnInput;
     window(x+Length(LTitle)+2,y,x+Length(Ltitle)+2+delka,y);
     clrscr;
     textattr:=LnStand;
     window(1,1,80,25);
     gotoxy(ix,iy);
end;

procedure LoginBox(x,y: byte; Var user: string; Var password: string);
label 1;
var
    I: integer;
    BLast,BPos: byte;
    key: char;
const LogTitle='Pihlen';
begin
     ESCResult:=false;
     savewin(x-1,y-1,x+33,y+8,wpole);
     wframe(x,y,x+32,y+5);
     gotoxy(x+16-(Length(LogTitle) div 2),y-1);
     textattr:=wcTitle;
     write(' ',LogTitle,' ');
     ShowLn('Uivatel',x+1,y,20);
     ShowLn('Heslo',x+1,y+2,23);
1:
     WEReadLn('                               ');
     WEReadBt(' Login ',LogOk,'Potvrzen zadanch daj ...');
     WEReadBt(' Znovu ',LogAg,'Opraven zadanch daj ...');
     WEReadBt(' Zruit ',LogEsc,'Nepihlen - ukonen aplikace ...');
     WEWidthLn;
     BtDirect(x,y);
     WEButtonLnY:=y+4;


     for I:=1 to BtCount do
      begin
           gotoxy(WEPosBt[I],WEButtonLnY);
           writeButton(Buttons[I].jmeno,btNoActive);
      end;
     InputLnS('Uivatel','Zadejte prosm svoje uivatelsk jmno ...',x+1,y,20,user);
     InputLnP('Heslo','Zadejte svoje vstupn heslo ...',x+1,y+2,23,password);

     BLast:=1;
     BPos:=1;

     gotoxy(WEPosBt[Bpos],WEButtonLnY);
     writebutton(Buttons[BPos].jmeno,btActive);
     textattr:=wcText;
     gotoxy(4,23);
     write(infoln(Buttons[BPos].text));

     repeat
           key:=GetLegalKey([CR,ESC,TAB]);
           case key of
            TAB:
                begin
                     BLast:=Bpos;
                     BPos:=BPos+1;
                     if BPos=BtCount+1 then BPos:=1;
                end;
            end;

           gotoxy(WEPosBt[BLast],WEButtonLnY);
           writebutton(Buttons[BLast].jmeno,btNoActive);
           gotoxy(WEPosBt[BPos],WEButtonLnY);
           writebutton(Buttons[BPos].jmeno,btActive);
           textattr:=wcText;
           gotoxy(4,23);
           write(infoln(Buttons[BPos].text));
     until key in [CR,ESC];

     case key of
     CR:
        begin
             if Buttons[Bpos].prikaz=LogOK then LOGResult:=true;
             if Buttons[Bpos].prikaz=LogAg then
              begin
                   WENul;
                   goto 1;
              end;
             if Buttons[Bpos].prikaz=LogEsc then
              begin
                   LOGResult:=false;
                   ESCResult:=true;
              end;
        end;
     ESC: begin
               LOGResult:=false;
               ESCResult:=true;
          end;
     end;

     restorewin(x-1,y-1,x+33,y+8,wpole);
     WENul;
end;


var ij: byte absolute $0000:$0449;

begin
     if ij<>7 then
      begin
           wcNormal:=16*lightgray+black;
           wcText:=16*lightgray+darkgray;
           wcDeskB:=16*lightgray+black;
           wcDeskW:=16*lightgray+white;
           wcActButton:=16*blue+yellow;
           wcNoButton:=16*brown+darkgray;
           wcButtonShadow:=16*lightgray+black;
           wcTitle:=16*lightgray+blue;
           lnInput:=16*white+blue;
           lnTitle:=16*lightgray+yellow;
           lnStand:=16*lightgray+black;
      end
     else
      begin
           wcNormal:=16*lightgray+black;
           wcText:=16*lightgray+black;
           wcDeskB:=16*lightgray+black;
           wcDeskW:=16*lightgray+black;
           wcActButton:=16*black+white;
           wcNoButton:=16*lightgray+black;
           wcButtonShadow:=16*lightgray+black;
           wcTitle:=16*lightgray+black;
           lnInput:=16*black+white;
           lnTitle:=16*lightgray+black;
           lnStand:=16*lightgray+black;

      end;
end.