unit SaveWind;
interface

type pbuf=^tbuf;                   { ukazatel na typ tbuf}
     tbuf=array [1..2000] of word; { pole 2000 slov pro uchovn cel obrazovky}
                                   { (80 * 25) = 2000 }
function VioSeg:word;             { Segment pamti, na kterm zan videopam؜}
                                  { je to $B000 pro Hercules, $B800 pro ostatn}
Procedure SaveWin(x1,y1,x2,y2:byte; var buffer:pbuf);
            { ukld okno o danch souadnicch do bufferu}
Procedure RestoreWin(x1,y1,x2,y2:byte; var buffer:pbuf);
            { obnovuje okno o danch souadnic z bufferu}

implementation
function VioSeg:word; assembler;
asm
        push BX
        push ES
        mov  ES,Seg0040
        mov  BX,ES:[0049h]
        cmp  BL,07
        jz   @@1      {hercules}
        mov  AX,SegB800
        jmp  @@2
@@1:    mov  AX,SegB000
@@2:    pop  ES
        pop  BX
end;

Procedure SaveWin(x1,y1,x2,y2:byte; var buffer:pbuf);
var x,y:byte;          {nate dan okno do pole }
    ofs,vseg,index:word;
begin
    if buffer=nil then new(buffer); { nen-li pro buffer rezervovna pam؜,
                                       udlej to}
    ofs:=((y1-1)*80+x1-1)*2;        { offset pozice x1,y1}
    vseg:=VioSeg;                   { segment ve videopamti, ze kter se te}
    index:=1;
    for y:=1 to (y2-y1+1) do        { prochzej a ukldej okno po dcch}
    begin
     for x:=0 to (x2-x1) do         { od zatku dku do konce}
     begin
       buffer^[index]:=memw[vseg:ofs+x*2]; { ulo obsah videopamti pro danou
                                             pozici (x,y)}
       inc(index);                  { zvten indexu pole o 1}
     end;
     inc(ofs,160)                   { posun o 1 dek; 160 = 80 znak * 2 byte}
    end
end;

Procedure RestoreWin(x1,y1,x2,y2:byte; var buffer:pbuf);
var x,y:byte;          {obnov okno z pole na obrazovku}
    ofs,vseg,index:word;
begin
    ofs:=((y1-1)*80+x1-1)*2;         { ofset pozice x1,y1}
    vseg:=VioSeg; index:=1;
    for y:=1 to (y2-y1+1) do
    begin
     for x:=0 to (x2-x1) do
     begin
       memw[vseg:ofs+x*2]:=buffer^[index]; { obnov pvodn obsah videopamti}
       inc(index);
     end;
     inc(ofs,160)     {posun o 1 dek}
    end
end;

end.